// Calculator.java
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class Calculator extends Applet implements ActionListener, ItemListener, AdjustmentListener {
   private TextField DisplayArea;
   private Button CalButtons[], OKbutton;
   private Panel CalculatePanel, ControlPanel,CP1,CP2;  //ControlPanel consists of CP1 and CP2
   private Scrollbar scrollRed,scrollGreen,scrollBlue;  //3 scrollbar for Red, Green, Blue

   private CheckboxGroup colorStyle;
   private Checkbox fg,bg;                     //fg--Foreground Color  bg--Background Color

   private int RedValue, GreenValue, BlueValue;  //Three color values
   private int fb;                              //fb check if it Forground or Background  
   private testCanvas c;                        //This is the Canvas in which to draw a Rectangle
   private Label labelRed,labelGreen,labelBlue; //just Lables for attention  
   private StringBuffer buff,buffT;             //buff--contains temporary string which user is 
                                                //inputing. 
                                                //buffT--String form of accumulator;
   private int totalValueInt;                   //Accumulator for interger
   private double totalValueDouble;             //Accumulator for double
   private boolean isDouble, oneStepOver;       //isDouble--if there is some float value
   private char opt;                            //opt is operation sign (+,-,*,/)
   private String tempString;                   //keep tempString;
 
   private String Names[]={"7",  "8",  "9",  "/",  "sqr",    //This is the caculator's panel
                           "4",  "5",  "6",  "*",  "1/X",                
                           "1",  "2",  "3",  "-",  "CE",                
                           "0",  ".",  "=",  "+",  "C"
                           };

   public void init()
   {  
      buff=new StringBuffer();
      buffT=new StringBuffer();
      setLayout( new BorderLayout( 5, 5 ) );
      
      // DisplayArea is the result to be displayed  
      DisplayArea=new TextField("");
      DisplayArea.setEditable(false);
      
      //
      CalculatePanel =new Panel();
      CalculatePanel.setLayout(new GridLayout(4, 5));

      CalButtons= new Button[Names.length];
      fb=0; //set Background Color
      for (int i=0; i<CalButtons.length; i++) {
         CalButtons[i] = new Button(Names[i]);
         CalButtons[i].addActionListener(this);
         CalculatePanel.add(CalButtons[i]);
      }  

      
      ControlPanel=new Panel();
      
      CP1=new Panel();
            
      CP1.setSize(250,70);
      labelRed=new Label();
      labelGreen=new Label();
      labelBlue=new Label();
      labelRed.setText("Red");
      labelGreen.setText("Green");
      labelBlue.setText("Blue");
      CP1.add(labelRed);
      CP1.add(labelGreen);
      CP1.add(labelBlue);
      
      //label location
      labelRed.setBounds(0,10,40,10);
      labelGreen.setBounds(0,30,40,10);
      labelBlue.setBounds(0,50,40,10);

      scrollRed = new Scrollbar( Scrollbar.HORIZONTAL,   255, 1, 0, 256 );
      scrollGreen = new Scrollbar( Scrollbar.HORIZONTAL, 255, 1, 0, 256 );
      scrollBlue = new Scrollbar( Scrollbar.HORIZONTAL,  255, 1, 0, 256 );
      scrollRed.addAdjustmentListener(this);
      scrollGreen.addAdjustmentListener(this);
      scrollBlue.addAdjustmentListener(this);
      CP1.setLayout(null);
      CP1.add( scrollRed );
      CP1.add( scrollGreen );
      CP1.add( scrollBlue ); 
      scrollRed.setBounds( 45, 10, 100, 10 );   
      scrollGreen.setBounds( 45,30, 100, 10 );  
      scrollBlue.setBounds( 45,50, 100, 10 );   

      c = new testCanvas();
      c.setSize(54,54);
      c.setBackground(Color.black);
      CP1.add(c);
      c.setLocation(170, 10);
      
      CP2=new Panel();
      CP2.setLayout(new GridLayout(3, 1));
      colorStyle=new CheckboxGroup();
      
      fg=new Checkbox("FG",colorStyle,true);
      fg.addItemListener(this);
      CP2.add(fg);
      bg=new Checkbox("BG",colorStyle,true);
      bg.addItemListener(this);
      CP2.add(bg);      
      fb=0;
      OKbutton=new Button("OK");
      OKbutton.addActionListener(this);
      CP2.add(OKbutton);
      
      ControlPanel.add(CP1);
      ControlPanel.add(CP2); 

      add(DisplayArea, BorderLayout.NORTH);
      add(CalculatePanel, BorderLayout.CENTER);
      add(ControlPanel, BorderLayout.SOUTH);
   }
  
   public void itemStateChanged( ItemEvent e)
   {
     //if changing foreground color, fb=1; if changing background color, fb=0;
     if (e.getSource()==fg) fb=1;
     else if (e.getSource()==bg) fb=0;
   }

   public void adjustmentValueChanged( AdjustmentEvent e)
   {
      if (e.getAdjustable()==scrollRed) { c.setRedValue(e.getValue()); }
      else if (e.getAdjustable()==scrollGreen) { c.setGreenValue(e.getValue()); }
           else if (e.getAdjustable()==scrollBlue) { c.setBlueValue(e.getValue()); }
   }  

   public void actionPerformed( ActionEvent e ) 
   {
       if (e.getSource()==OKbutton) { 
          if (fb==1) { 
            for (int i=0; i<CalButtons.length; i++) {
               CalButtons[i].setForeground(new Color(c.r,c.g,c.b));
            }
          } 
          else if (fb==0) {
             for (int i=0; i<CalButtons.length; i++) {
               CalButtons[i].setBackground(new Color(c.r,c.g,c.b));
             }             
          }
          CalculatePanel.repaint();
       }

       if (e.getSource()==CalButtons[0]) {                  //---7
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("7"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[1]) {                  //---8
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("8"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[2]) {                  //---9
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("9"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[5]) {                 //---4
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("4"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[6]) {                 //---5
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("5"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[7]) {                 //---6
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("6"); 
          DisplayArea.setText(buff.toString());
       }                  
       if (e.getSource()==CalButtons[10]) {                //---1
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("1"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[11]) {                //---2
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("2"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[12]) {                //---3
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("3"); 
          DisplayArea.setText(buff.toString());
       }          

       if (e.getSource()==CalButtons[15]) {                //---0
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          } 
          buff.append("0"); 
          DisplayArea.setText(buff.toString());
       }          
       if (e.getSource()==CalButtons[16]) {                //---.
          if (oneStepOver==true) {
            buff=new StringBuffer();
            oneStepOver=false;
          }
          buff.append("."); 
          DisplayArea.setText(buff.toString());
          isDouble=true;
       }       
       if (e.getSource()==CalButtons[14]) {                //---CE
          buff=new StringBuffer(); 
          DisplayArea.setText(buff.toString());
          
       }
       if (e.getSource()==CalButtons[19]) {                //---C
          buff=new StringBuffer();
          buffT=new StringBuffer();
          isDouble=false;
          DisplayArea.setText(buff.toString());
       }

       if (e.getSource()==CalButtons[18]) {                //---+
          if (buffT.length()==0) {
             initialOpt();
          }
          else {  
            if (buff.length()!=0)  {  
               if (isDouble==true) {
                 doubleOpt();
               }
               else {     
                 intOpt();
               }
            }
          }   
          opt='+';
          oneStepOver=false;
       }                   
     
       if (e.getSource()==CalButtons[13]) {                //---"-"
          if (buffT.length()==0) {
             initialOpt();
          }
          else {  
            if (buff.length()!=0)  {  
               if (isDouble==true) {
                 doubleOpt();
               }
               else {     
                 intOpt();
               }
            }
          }   
          opt='-'; 
          oneStepOver=false;
       }          

       if (e.getSource()==CalButtons[8]) {                //---*
          if (buffT.length()==0) {
             initialOpt();
          }
          else {  
            if (buff.length()!=0)  {  
               if (isDouble==true) {
                 doubleOpt();
               }
               else {     
                 intOpt();
               }
            }
          }   
          opt='*';
          oneStepOver=false;
       }                   

       if (e.getSource()==CalButtons[3]) {                //---/
          if (buffT.length()==0) {
             initialOpt();
          }
          else {  
            if (buff.length()!=0)  {  
               if (isDouble==true) {
                 doubleOpt();
               }
               else {     
                 intOpt();
               }
            }
          }   
          opt='/';
          oneStepOver=false;
       }                   
     
        //oneStepOver -- if you press "=" and get the result, then if you press another digit 
        //number immediately. This variable will reset the variable "buf" to start a new
        //computation. If oneStepOver == false, means that you press a operator ( +, -, * ,/) 
        //after you see the result, you need another computation using this result.
 
       if (e.getSource()==CalButtons[17]) {                   //---=
            if ((buffT.length()!=0)&&(buff.length()!=0))  {   
               if (isDouble==true) {
                 doubleOpt();
               }
               else {     
                 intOpt();
               }  
               buff=buffT;
               buffT=new StringBuffer();  
               oneStepOver=true;               
            }
       }                         
       
       if (e.getSource()==CalButtons[4]) {                //---Sqr
          if (buff.length()!=0) {
             if (isDouble==true) {
                tempString=String.valueOf(sqr(Double.valueOf(buff.toString()).doubleValue()));
             }                  
             else {
                tempString=String.valueOf(sqr(Integer.parseInt(buff.toString()))); 
             }
             DisplayArea.setText(tempString);
             buff=new StringBuffer(tempString); 
          } 
       }

       if (e.getSource()==CalButtons[9]) {               //---1/X
          if (buff.length()!=0) { 
              totalValueDouble=1/Double.valueOf(buff.toString()).doubleValue();
              tempString=String.valueOf(totalValueDouble);
              DisplayArea.setText(tempString);
              buff=new StringBuffer(tempString);           
              isDouble=true;
          }
       }

   }  // actionPerformed()
      
   private int sqr(int x) {                            //calculate the sqr for integer
     return x*x;
   }
   
   private double sqr(double x) {                      //calculate the sqr for double
     return x*x;
   }

   private void initialOpt() {                                //take the first number
     buffT=buff;
     buff=new StringBuffer();
     DisplayArea.setText(buffT.toString());
   }

   private void doubleOpt() {                                //caculate the double value
     switch(opt) {
       case '+': totalValueDouble=Double.valueOf(buffT.toString()).doubleValue()+Double.valueOf(buff.toString()).doubleValue(); 
                 break;
       case '-': totalValueDouble=Double.valueOf(buffT.toString()).doubleValue()-Double.valueOf(buff.toString()).doubleValue(); 
                 break;
       case '*': totalValueDouble=Double.valueOf(buffT.toString()).doubleValue()*Double.valueOf(buff.toString()).doubleValue(); 
                 break;
       case '/': totalValueDouble=Double.valueOf(buffT.toString()).doubleValue()/Double.valueOf(buff.toString()).doubleValue(); 
                 break;
     }
     buffT=new StringBuffer(Double.toString(totalValueDouble));
     DisplayArea.setText(Double.toString(totalValueDouble));
     buff=new StringBuffer();          
   }

   private void intOpt() {                                  //caculate the integer value 
     switch(opt) {                                          //almost the same as doubleOpt() 
       case '+': totalValueInt=Integer.parseInt(buffT.toString())+Integer.parseInt(buff.toString()); break;
       case '-': totalValueInt=Integer.parseInt(buffT.toString())-Integer.parseInt(buff.toString()); break;
       case '*': totalValueInt=Integer.parseInt(buffT.toString())*Integer.parseInt(buff.toString()); break;
       case '/': totalValueInt=Integer.parseInt(buffT.toString())/Integer.parseInt(buff.toString()); break;
       case '%': totalValueInt=Integer.parseInt(buffT.toString())%Integer.parseInt(buff.toString()); break;
     }
      buffT=new StringBuffer(Integer.toString(totalValueInt));
      DisplayArea.setText(Integer.toString(totalValueInt));
      buff=new StringBuffer();  
   }

} // end of class Calculator



// Setup an Canvas to draw the test Rectangle to see the color is satifatory

class testCanvas extends Canvas {

   public int r,g,b;                                      //color Red, Green, Blue

   public testCanvas()                                    //default (r,g,b) value
   {
      r=255;
      g=255;
      b=255;
   }

   public void paint( Graphics graph )
   {
      graph.setColor(new Color(r,g,b));
      graph.fillRect(2, 2, 50, 50);      
   }

   public void setRedValue( int x )
   {
      r = x;
      repaint();
   }

   public void setGreenValue( int y )
   {
      g = y;
      repaint();
   }
   public void setBlueValue( int z )
   {
      b = z;
      repaint();
   }
}

